*
*  _memcpyw.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

	.offset	4
dst:	ds.l	1
src:	ds.l	1
cnt:	ds.l	1

~dst	reg	a0
~src	reg	a1
~cnt0	reg	a2
~cnt	reg	d2
~cntH	reg	d1

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** short* _memcpyw(short* dst, CONST short* src, long cnt)
**
	xdef	_hmemcpyw
_hmemcpyw:
	xdef	__memcpyw
__memcpyw:
	movem.l	dst(sp),~dst/~src/~cnt0		. a0=dst, a1=src, a2=cnt

	move.l	~dst,d0			* d0=dst
	move.l	~cnt0,~cnt		* d2=cnt
	beq.s	memcpyw_end

	cmp.l	#16,~cnt
	blo.s	memcpyw_single

	lsr.l	#3,~cnt			* cnt /= 3
	subq.l	#1,~cnt
	move.l	~cnt,~cntH
	swap	~cntH
memcpyw8_loop:
	move.w	(~src)+,(~dst)+
	move.w	(~src)+,(~dst)+
	move.w	(~src)+,(~dst)+
	move.w	(~src)+,(~dst)+
	move.w	(~src)+,(~dst)+
	move.w	(~src)+,(~dst)+
	move.w	(~src)+,(~dst)+
	move.w	(~src)+,(~dst)+
	dbra	~cnt,memcpyw8_loop
	dbra	~cntH,memcpyw8_loop
	move.w	~cnt0,~cnt
	andi.w	#7,~cnt
	beq.s	memcpyw_end

memcpyw_single:
	subq.l	#1,~cnt
*	move.l	~cnt,~cntH
*	swap	~cntH

memcpyw_loop:
	move.w	(~src)+,(~dst)+
	dbra	~cnt,memcpyw_loop
*	dbra	~cntH,memcpyw_loop
memcpyw_end:
*	move.l	dst(sp),d0
	rts
	.end
