*
*  _memrcpyl.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

	.offset	4
dst:	ds.l	1
src:	ds.l	1
cnt:	ds.l	1

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** long* _memrcpyl(long* dst, CONST long* src, long cnt)
**
	xdef	_hmemrcpyl
_hmemrcpyl:
	xdef	__memrcpyl
__memrcpyl:
	movem.l	dst(sp),a0-a2		. a0=dst, a1=src, a2=cnt

R_dst	reg	a0
R_src	reg	a1
R_cnt	reg	d2
R_cntH	reg	d1

	move.l	R_dst,d0		. d0=dst
	move.l	a2,R_cnt		. d2=cnt
	beq.s	memcpyl_end

*	.if	MPU>=68020
*	lea.l	(R_dst,R_cnt.l*4),R_dst
*	lea.l	(R_src,R_cnt.l*4),R_src
*	.else
	move.l	R_cnt,d1
	lsl.l	#2,d1
	adda.l	d1,R_dst
	adda.l	d1,R_src
*	.endif

	subq.l	#1,R_cnt
	move.l	R_cnt,R_cntH
	swap	R_cntH

memcpyl_loop:
	move.l	-(R_src),-(R_dst)
	dbra	R_cnt,memcpyl_loop
	dbra	R_cntH,memcpyl_loop
memcpyl_end:
	rts
	.end
