*
*  _memsetl.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
	.ifndef	MPU
MPU	equ	68000
	.endif
	xref	__hmem_version

	.offset	4
buf:	ds.l	1
dat:	ds.l	1
cnt:	ds.l	1

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** long* _memsetl(long* buf, long dat, size_t cnt)
**
	xdef	_hmemsetl
_hmemsetl:
	xdef	__memsetl
__memsetl:
	movem.l	buf(sp),d0-d2		. d0=buf, d1=dat, d2=cnt

R_buf	reg	a0
R_dat	reg	d1
R_cnt	reg	d2
R_cntH	reg	d0

	movea.l	d0,R_buf
	move.l	R_cnt,d0
	beq.s	memsetl_end

*	.if	MPU>=68020
*	lea	(a0,R_cnt.l*4),a0
*	.else
	lsl.l	#2,d0
	adda.l	d0,R_buf
*	.endif
	subq.l	#1,R_cnt
	move.l	R_cnt,R_cntH
	swap	R_cntH

memsetl_loop:
	move.l	R_dat,-(R_buf)
	dbra	R_cnt,memsetl_loop
	dbra	R_cntH,memsetl_loop
memsetl_end:
	move.l	R_buf,d0
	rts
	.end
