*
*  _memsetw.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

	.offset	4
buf:	ds.l	1
dat:	ds.l	1
cnt:	ds.l	1

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** short* _memsetw(short* buf, short dat, size_t cnt)
**
	xdef	_hmemsetw
_hmemsetw:
	xdef	__memsetw
__memsetw:
	movem.l	buf(sp),d0-d2		. d0=buf, d1=dat, d2=cnt

R_buf	reg	a0
R_dat	reg	d1
R_cnt	reg	d2
R_cntH	reg	d0

	movea.l	d0,R_buf
	adda.l	R_cnt,R_buf
	adda.l	R_cnt,R_buf
	subq.l	#1,R_cnt
	bcs	memsetw_end
	move.l	R_cnt,R_cntH
	swap	R_cntH

memsetw_loop:
	move.w	R_dat,-(R_buf)
	dbra	R_cnt,memsetw_loop
	dbra	R_cntH,memsetw_loop
	move.l	R_buf,d0
memsetw_end:
	rts
	.end
