*
*  _rmemchr.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

	.offset	4
buf	ds.l	1			. ̈ŏIAhX
c	ds.l	1			. 
cnt	ds.l	1			. ő匟

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** void* _rmemchr(const void *buf, int c, size_t cnt) ;
**
	xdef	_hrmemchr
_hrmemchr:
	xdef	__rmemchr
__rmemchr:
	movem.l	buf(sp),d0-d2		. d0=buf, d1=c, d2=len

R_buf	reg	a0
R_c	reg	d1
R_cnt	reg	d2
R_cntH	reg	d0

	movea.l	d0,R_buf		. a0:̈擪AhX

	subq.l	#1,R_cnt		. [vJEg␳
	bcs.s	rmemchr_not_found
	move.l	R_cnt,R_cntH
	swap	R_cntH

rmemchr_loop:
	cmp.b	-(R_buf),R_c		. H
	dbeq	R_cnt,rmemchr_loop
	beq	rmemchr_found
	dbra	R_cntH,rmemchr_loop
rmemchr_not_found:
	moveq.l	#0,d0			. NULL
	rts
rmemchr_found:
	move.l	R_buf,d0
	rts
	.end
