*
*  memchr.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

	.offset	4
buf	ds.l	1			. ̈擪AhX
c	ds.l	1			. 
cnt	ds.l	1			. ő匟

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** void* memchr(const void *buf, int c, size_t cnt) ;
**
	xdef	_hmemchr
_hmemchr:
	xdef	_memchr
_memchr:
	movem.l	buf(sp),d0-d2		. 
	movea.l	d0,a0
	subq.l	#1,d2			. [vJEg␳
	bcs.s	memchr_not_found
	move.l	d2,d0
	swap	d0

memchr_loop:
	cmp.b	(a0)+,d1		. H
	dbeq	d2,memchr_loop
	beq.s	memchr_found
	dbra	d0,memchr_loop
memchr_not_found:
	moveq.l	#0,d0			. NULL
	rts

memchr_found:
	move.l	a0,d0
	subq.l	#1,d0			. AhX␳
	rts
	.end
