*
*  _memcmpl.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

	.offset	4
mem1:	ds.l	1
mem2:	ds.l	1
len:	ds.l	1			. rO[h

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** int	_memcmpl(const long* mem1, const long* mem2, size_t len)
**
	xdef	_hmemcmpl
_hmemcmpl:
	xdef	__memcmpl
__memcmpl:
	movem.l	mem1(sp),a0-a2		. a0=mem1, a1=mem2, a2=len

R_mem1	reg	a0
R_mem2	reg	a1
R_cnt	reg	d2
R_cntH	reg	d1

	move.l	a2,R_cnt		. d2=len
	ble	memcmp_equal		. len ܂͂OȂI
	cmpa.l	R_mem1,R_mem2
	beq	memcmp_equal		. ̈̔rȂI

	subq.l	#1,R_cnt		. [vJE^␳
	move.l	R_cnt,R_cntH
	swap	R_cntH

memcmp_loop:
	cmpm.l	(R_mem2)+,(R_mem1)+
	dbne	R_cnt,memcmp_loop
	bne.s	memcmp_not_equal
	dbra	R_cntH,memcmp_loop
memcmp_equal:
	moveq.l	#0,d0			. ret=0
memcmp_end:
	rts
memcmp_not_equal
	move.l	-4(R_mem1),d0
	sub.l	-4(R_mem2),d0		* d0 = *R_mem1 - *R_mem2
	rts
	.end
