*
*  _memcmpsl.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

	.offset	4
mem1:	ds.l	1
mem2:	ds.l	1
len:	ds.l	1			. rO[h

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** int	_memcmpsl(const long* mem1, const long* mem2, size_t len)
**
	xdef	_hmemcmpsl
_hmemcmpsl:
	xdef	__memcmpsl
__memcmpsl:
	movem.l	mem1(sp),a0-a2		. a0=mem1, a1=mem2, a2=len

R_mem1	reg	a0
R_mem2	reg	a1
R_len	reg	d2
R_lenH	reg	d1

	move.l	a2,R_len		. d2=len
	ble	memcmp_equal		. len ܂͂OȂI
	cmpa.l	R_mem1,R_mem2
	beq	memcmp_equal		. ̈̔rȂI

	subq.l	#1,R_len		. [vJE^␳
	move.l	R_len,R_lenH
	swap	R_lenH

memcmp_loop:
	cmpm.l	(R_mem1)+,(R_mem2)+
	dbne	R_len,memcmp_loop
	bgt	memcmp_plus		. mem1>mem2
	blt	memcmp_minus		. mem1<mem2
	dbra	R_lenH,memcmp_loop
memcmp_equal:
	moveq.l	#0,d0			. ret=0
memcmp_end:
	rts
memcmp_plus:
	moveq.l	#1,d0			. ret=1
	rts
memcmp_minus:
	moveq.l	#-1,d0			. ret=-1
	rts
	.end
