*
*  _memcpyl.s: part of libhmem(high speed memory operation library)
*  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	equ	68000
.endif
	xref	__hmem_version

	.offset	4
dst:	ds.l	1
src:	ds.l	1
cnt:	ds.l	1

~dst	reg	a0
~src	reg	a1
~cnt0	reg	a2
~cnt	reg	d2
~cntH	reg	d1

	.text
	.even
.if	MPU>=68020
.ifdef	QUAD_ALIGN
	.quad
.endif
.endif
**
** long* _memcpyl(long* dst, CONST long* src, long cnt)
**
	xdef	_hmemcpyl
_hmemcpyl:
	xdef	__memcpyl
__memcpyl:
	movem.l	dst(sp),~dst/~src/~cnt0		* a0=dst, a1=src, a2=cnt

	move.l	~dst,d0			* d0=dst
	move.l	~cnt0,~cnt		* d2=cnt
	beq.s	memcpyl_end

	cmp.l	#16,~cnt
	blo.s	memcpyl_single

	lsr.l	#3,~cnt			* cnt /= 8
	subq.l	#1,~cnt
	move.l	~cnt,~cntH
	swap	~cntH
memcpyl8_loop:
	move.l	(~src)+,(~dst)+
	move.l	(~src)+,(~dst)+
	move.l	(~src)+,(~dst)+
	move.l	(~src)+,(~dst)+
	move.l	(~src)+,(~dst)+
	move.l	(~src)+,(~dst)+
	move.l	(~src)+,(~dst)+
	move.l	(~src)+,(~dst)+
	dbra	~cnt,memcpyl8_loop
	dbra	~cntH,memcpyl8_loop
	move.w	~cnt0,~cnt
	andi.w	#7,~cnt
	beq.s	memcpyl_end
memcpyl_single:
	subq.l	#1,~cnt
*	move.l	~cnt,~cntH
*	swap	~cntH

memcpyl_loop:
	move.l	(~src)+,(~dst)+
	dbra	~cnt,memcpyl_loop
*	dbra	~cntH,memcpyl_loop
memcpyl_end:
*	move.l	dst(sp),d0
	rts
	.end
