
#ifndef	_HMEMORY_H_
/*
 *  hmemory.h: part of libhmem(high speed memory operation library)
 *  Copyright  1992-95  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#define	_HMEMORY_H_	1

#include	"ansidecl.h"

#define	HAVE_BCOPY	1
#define	HAVE_BZERO	1

extern char*	_hmem_version;

extern void*	EXFUN(hmemchr, (void* buf, int c, long cnt));
extern void*	EXFUN(_memcchr, (void* buf, int c, long cnt));
extern void*	EXFUN(hmemcchr, (void* buf, int c, long cnt));
extern void*	EXFUN(_rmemchr, (void* buf, int c, long cnt));
extern void*	EXFUN(hrmemchr, (void* buf, int c, long cnt));
extern void*	EXFUN(_rmemcchr, (void* buf, int c, long cnt));
extern void*	EXFUN(hrmemcchr, (void* buf, int c, long cnt));

extern int		EXFUN(hmemcmp, (CONST void* buf1, CONST void* buf2, long cnt));
extern int		EXFUN(_memcmpl, (CONST unsigned long* buf1, CONST unsigned long* buf2, long cnt));
extern int		EXFUN(hmemcmpl, (CONST unsigned long* buf1, CONST unsigned long* buf2, long cnt));
extern int		EXFUN(_memcmpsl, (CONST long* buf1, CONST long* buf2, long cnt));
extern int		EXFUN(hmemcmpsl, (CONST long* buf1, CONST long* buf2, long cnt));

extern void*	EXFUN(hmemcpy, (void* dst, CONST void* src, long cnt));
extern short*	EXFUN(_memcpyw, (short* dst, CONST short* src, long cnt));
extern short*	EXFUN(hmemcpyw, (short* dst, CONST short* src, long cnt));
extern long*	EXFUN(_memcpyl, (long* dst, CONST long* src, long cnt));
extern long*	EXFUN(hmemcpyl, (long* dst, CONST long* src, long cnt));
extern long*	EXFUN(_memrcpyl, (long* dst, CONST long* src, long cnt));
extern long*	EXFUN(hmemrcpyl, (long* dst, CONST long* src, long cnt));
extern long*	EXFUN(_blkcpy, (long* dst, CONST long* src, long cnt));
extern long*	EXFUN(hblkcpy, (long* dst, CONST long* src, long cnt));

extern void*	EXFUN(hmemset, (void* buf, int data, long cnt));
extern short*	EXFUN(_memsetw, (short* buf, short data, long cnt));
extern short*	EXFUN(hmemsetw, (short* buf, short data, long cnt));
extern long*	EXFUN(_memsetl, (long* buf, long data, long cnt));
extern long*	EXFUN(hmemsetl, (long* buf, long data, long cnt));
extern long*	EXFUN(_blkset, (long* buf, long data, long cnt));
extern long*	EXFUN(hblkset, (long* buf, long data, long cnt));

#define	/*long**/_blkclr(/*long**/buf,/*long*/cnt)	_blkset((buf),0L,(cnt))

#endif	/*_HMEMORY_H_*/
